=== modified file 'branchview/graphcell.py'
--- branchview/graphcell.py	2008-01-22 22:58:29 +0000
+++ branchview/graphcell.py	2008-04-02 23:21:11 +0000
@@ -149,19 +149,18 @@
         box_size = self.box_size(widget)
 
         ctx.set_line_width(box_size / 8)
-        ctx.set_line_cap(cairo.LINE_CAP_ROUND)
 
         # Draw lines into the cell
         for start, end, colour in self.in_lines:
             self.render_line (ctx, cell_area, box_size,
                          bg_area.y, bg_area.height,
-                         start, end, colour)
+                         start, end, colour, flags)
 
         # Draw lines out of the cell
         for start, end, colour in self.out_lines:
             self.render_line (ctx, cell_area, box_size,
                          bg_area.y + bg_area.height, bg_area.height,
-                         start, end, colour)
+                         start, end, colour, flags)
 
         # Draw the revision node in the right column
         (column, colour) = self.node
@@ -169,6 +168,12 @@
                 cell_area.y + cell_area.height / 2,
                 box_size / 4, 0, 2 * math.pi)
 
+        if flags & gtk.CELL_RENDERER_SELECTED:
+            ctx.set_source_rgb(1.0, 1.0, 1.0)
+            ctx.set_line_width(box_size / 4)
+            ctx.stroke_preserve()
+            ctx.set_line_width(box_size / 8)
+
         self.set_colour(ctx, colour, 0.0, 0.5)
         ctx.stroke_preserve()
 
@@ -177,8 +182,9 @@
 
         self.render_tags(ctx, widget.create_pango_context(), cell_area, box_size)
     
-    def render_line(self, ctx, cell_area, box_size, mid, height, start, end, colour):
+    def render_line(self, ctx, cell_area, box_size, mid, height, start, end, colour, flags):
         if start is None:
+            ctx.set_line_cap(cairo.LINE_CAP_ROUND)
             x = cell_area.x + box_size * end + box_size / 2
             ctx.move_to(x, mid + height / 3)
             ctx.line_to(x, mid + height / 3)
@@ -186,29 +192,39 @@
             ctx.line_to(x, mid + height / 6)
             
         elif end is None:
+            ctx.set_line_cap(cairo.LINE_CAP_ROUND)
             x = cell_area.x + box_size * start + box_size / 2
             ctx.move_to(x, mid - height / 3)
             ctx.line_to(x, mid - height / 3)
             ctx.move_to(x, mid - height / 6)
             ctx.line_to(x, mid - height / 6)
+
         else:
+            ctx.set_line_cap(cairo.LINE_CAP_BUTT)
             startx = cell_area.x + box_size * start + box_size / 2
             endx = cell_area.x + box_size * end + box_size / 2
             
             ctx.move_to(startx, mid - height / 2)
             
             if start - end == 0 :
-                ctx.line_to(endx, mid + height / 2)
+                ctx.line_to(endx, mid + height / 2 + 1)
             else:
                 ctx.curve_to(startx, mid - height / 5,
                              startx, mid - height / 5,
                              startx + (endx - startx) / 2, mid)
-                
+
                 ctx.curve_to(endx, mid + height / 5,
                              endx, mid + height / 5 ,
-                             endx, mid + height / 2)
-                
+                             endx, mid + height / 2 + 1)
+
+        if flags & gtk.CELL_RENDERER_SELECTED:
+            ctx.set_source_rgb(1.0, 1.0, 1.0)
+            ctx.set_line_width(box_size / 5)
+            ctx.stroke_preserve()
+            ctx.set_line_width(box_size / 8)
+
         self.set_colour(ctx, colour, 0.0, 0.65)
+
         ctx.stroke()
 
     def render_tags(self, ctx, pango_ctx, cell_area, box_size):

